/*
 *
 *  High level data transfer stuff.
 *
 *  Copyright (c) 1999 Richard J.M. Close
 *  Copyright (c) 1999 Pavel Machek <pavel@suse.cz>
 *  Copyright (c) 1999 Jamie Lokier
 *
 *  Can be freely distributed and used under the terms of the GNU GPL.
 */

#include "data.h"

// -----------------------------------------------------------
// General stuff

void dual_port_rx(void)
{

  int val;

  val = dp_int_regread(0xB0);
#if 0
  // [esp + 13h] = val ? byte 1 of ecx on stack?
  if ((val & 0x1f) == 0) goto exit;

  edi = io_dce_rx_wptr;
  val--;
  esi = val;
  bl = 0x90;
  esi++;

 loc_2DC86:
  al = bl;
  bl++;
  *io_dce_rx_wptr = dp_int_regread(al);
  ecx = io_dce_rx_wptr;

  io_dce_rx_wptr++;
  io_dce_rx_wptr++;

  if (io_dce_rx_wptr >= io_dce_rx_eptr)
	io_dce_rx_wptr = io_dce_rx_sptr; 

  esi--;
  if (esi > 0) goto loc_2DC86;

  dl = [esp + 13h];
  if ((dl & 0xE0) == 0) goto exit;

  if ((dl & 0x20) != 0) 
	*edi = *edi | 0x4000;

  if ((dl & 0xC0) == 0) goto exit;
  
  *ecx = *ecx | 0x8000;
  ax = *ecx;

  if ((dl & 0x40) == 0) goto exit;
  ax = ax | 0x2800;
  *ecx = ax;

  exit:
#endif
  dp_int_regread(0xB0);
}

void dual_port_tx(void)
{
}

// -----------------------------------------------------------
// V8 stuff.

// -----------------------------------------------------------
// V34 stuff.

void process_v34(void)
{  
  printf( "Process v34?\n" );
#if 1
  if (!(dp_int_regread(0xb6) & 0x10))
    goto lE07;
  if (S(0x6b) != 1)
    goto lE02;
  if (V34Mode != 0)
    goto lE02;
  io_dual_port_rx();
  goto lE07;

 lE02:
  dual_port_rx();
 lE07:
  if (dp_int_regread(0xb6) & 1)
    dual_port_tx();
#endif
}

// -----------------------------------------------------------
// 56K stuff.

void dp_56k_idle (void)
{
  //000_dp_56k_idle_0	; sub__dp_task_12+EFp

  S(0x6b) = 0;
  if (dp_56k_state != 0) {
     x_modem_state = 1;
     dp_run_rom();
  }
  dp_56k_state = 0;
}

// Dummy.
void dp_56k_background (void)
{
  printf("dp_56k_background: Warning not yet implemented!\n");
}
