/*
 * Call related stuff, mostly to do with dialling.
 *
 * Copyright 1999 Pavel Machek
 * Copyright 1999 Jamie Lokier
 * Copyright 1999 R.J.M. Close
 *
 * Can be distributed under GPL
 */

#ifndef LT_DP_CALL_H

#define LT_DP_CALL_H 1

#include "homol.h"
#include "modem_globals.h"
#include "portIO.h"
#include "dp_v8bis.h"

void dp_DTMF_dial_cmd (unsigned char digit);

// Pulse dial!
void dp_pulse_dial_cmd(int arg);

// Set up tone detection.
void dp_detect_tones_cmd (void);

// Detects the dial tone. Well actually it seems to detect the presence
// of a signal greater than (H_dialtone_level*2) for 2.5 seconds.
// Currently doesn't work! since dp_read_dsp_ram(0x3A); always returns 0.
// needs tidying up.
bool dp_dial_tone_detected (void);

// Returns True if another modem answers the call.
bool dp_answer_tone_detected(void);

bool dp_busy_tone_detected (void);
bool dp_quiet_answer_detected(void);

bool dp_ring_detected(void);
bool dp_ringback_detected(void);
void dp_detect_over_current (unsigned char arg1);

void dp_update_blacklist (char* szDialstring, unsigned char arg2);

void dp_dial (void);

// Home made stuff, extracted from dp_periodic_task.
void bodge_init_dial (void);
void bodge_after_dial_init (void);
bool call_detected(void);

void connect_to_modem(void);

// Variables
unsigned short dp_busy_on_cadence;
unsigned short dp_busy_off_cadence;
unsigned short dp_continuous_busy_timer;

unsigned short dp_no_ringback_timer, dp_ringback_on_timer, dp_ringback_off_timer;

int dp_ringback_state;
short dp_ringback_on_cadence;
short dp_ringback_off_cadence;
unsigned char dp_ringback_cycles;

#endif
