/*
 * Header file with homologenisation(sp?) stuff in.
 *
 * Copyright 1999 Jamie Lokier / Pavel Machek /R.J.M. Close,
 *
 * Distribute under the terms and conditions of the GPL.
 */

#ifndef HOMOL_H

#define HOMOL_H 1

unsigned char _S [0xd7];

#define homol (_S + 0x86)

/* Offsets 0x86 to 0xd6 are actually 0-80 in the homol array.
   Lower offsets are in the S array.
   homol [0] is the current country code.
   homol [80] seems to be set for European countries (look for tbr21). */
#define S(x) (*((x) < 0x86 ? _S + (x) : homol + (x) - 0x86))

/* Generated from S_base by xS.pl. */

#define S_auto_answer_ring_count			_S [0]
#define S_ring_count					_S [1]
#define S_AT_escape_char				_S [2]
#define S_command_termination_char			_S [3]
#define S_response_format_char				_S [4]
#define S_command_backspace_char			_S [5]
#define S_wait_before_dialing				_S [6]
#define S_connect_completion_timeout			_S [7]
#define S_comma_dial_time				_S [8]
#define S_auto_disconnect_delay				_S [10]
#define S_DTMF_dial_speed				_S [11]
#define S_escape_guard_time				_S [12]
#define S_general_options				_S [14]
#define S_V24_options					_S [21]
#define S_results_options				_S [22]
#define S_sleep_mode_timer_1				_S [24]
#define S_V34_enable					_S [28]
#define S_inactivity_timer				_S [30]
#define S_synthetic_ring_volume				_S [32]
#define S_synthetic_ring_frequency			_S [33]
#define S_data_calling_tone				_S [35]
#define S_negotiation_fallback				_S [36]
#define S_dial_line_rate				_S [37]
#define S_enable_K56flex_settings			_S [38]
#define S_auto_rate					_S [42]
#define S_auto_mode					_S [43]
#define S_LAPM_negotiation_flags			_S [48]
#define S_sleep_mode_timer_2				_S [89]
#define S_local_phone_status				_S [90]
#define S_line_transmit_level				_S [91]
#define S_network_codec_type				_S [108]
#define S_speaker_enable				_S [55]
#define S_speaker_volume				_S [54]
#define country_code					homol [0]
#define H_pulse_dial_make_time				homol [1]
#define H_pulse_dial_break_time				homol [2]
#define H_pulse_dial_digit_pattern			homol [3]
#define H_DTMF_high_tone_level_ndB			homol [4]
#define H_min_DTMF_dial_speed				homol [5]
#define H_max_DTMF_dial_speed				homol [6]
#define H_call_progress_detection_threshold_ndB		homol [7]
#define H_dial_tone_detection_delay			homol [8]
#define H_dial_tone_hole_time				homol [9]
#define H_ring_count_reset_delay			homol [10]
#define H_min_auto_answer_ring_count			homol [11]
#define H_max_auto_answer_ring_count			homol [12]
#define H_min_ring_signal_period			homol [13]
#define H_max_ring_signal_period			homol [14]
#define H_min_ring_cadence_on_time			homol [15]
#define H_min_ring_cadence_off_time			homol [16]
#define H_min_busy_cadence_on_time			homol [17]
#define H_max_busy_cadence_on_time			homol [18]
#define H_busy_cycles_threshold				homol [19]
#define H_min_busy_cadence_off_time			homol [20]
#define H_max_busy_cadence_off_time			homol [21]
#define H_detect_number_unavailable			homol [22]
#define H_answer_tone_validation_time			homol [23]
#define H_blacklist_or_delay_flag			homol [24]
#define H_max_failure_count_before_blacklist		homol [25]
#define H_troubled_call_delay				homol [26]
#define H_ineffective_call_delay			homol [27]
#define H_erroneous_call_delay				homol [28]
#define H_blacklist_duration				homol [29]
#define H_overcurrent_sense_validation_time		homol [30]
#define H_calling_tone_flag				homol [31]
#define H_blind_dial_flag				homol [32]
#define H_busy_detect_disable				homol [33]
#define H_guard_tone_type				homol [34]
#define H_bell_modes_permitted				homol [35]
#define H_off_hook_restrictions				homol [36]
#define H_shunt_relay_on_time				homol [37]
#define H_hook_flash_time				homol [38]
#define H_min_blind_dial_pause				homol [39]
#define H_max_blind_dial_pause				homol [40]
#define H_min_no_answer_timeout				homol [41]
#define H_max_no_answer_timeout				homol [42]
#define H_min_dial_pause_time				homol [43]
#define H_max_dial_pause_time				homol [44]
#define H_min_no_carrier_disconnect_time		homol [45]
#define H_max_no_carrier_disconnect_time		homol [46]
#define H_transmit_level_ndB				homol [47]
#define H_dial_modifier_validation			homol [48]
#define H_TAD_rx_gain					homol [49]
#define H_full_wave_ring_detect				homol [50]
#define H_max_failed_attempts_stage_1			homol [51]
#define H_max_failed_attempts_anywhere			homol [52]
#define H_erronous_call_increment_count			homol [53]
#define H_dial_tone_validation_time			homol [54]
#define H_detect_busy_tone_during_dial_tone		homol [55]
#define H_DTMF_high_low_tone_level_difference_dB	homol [56]
#define H_not_local_phone_detection_in_speakerphone	homol [57]
#define H_not_pulse_dial_flag				homol [58]
#define H_dial_tone_or_call_progress_filter		homol [59]
#define H_dial_tone_detection_threshold_dB		homol [60]
#define H_disallow_ABCD_dialing				homol [61]
#define H_comma_pause_duration_limit			homol [62]
#define H_TAD_tx_level_dB				homol [63]
#define H_data_or_fax_carrier_rx_threshold_dB		homol [64]
#define H_no_dialtone_timeout_with_W_modifier		homol [65]
#define H_data_or_fax_answer_detection_threshold_dB	homol [66]
#define H_dialtone_level				homol [67]
#define H_fax_rx_threshold_dB				homol [68]
#define H_disallow_mixed_tone_and_pulse_dial		homol [69]
#define H_ringer_impedance_relay_flag			homol [70]
#define H_DC_loop_VI_characteristics_relay_flag		homol [71]
#define H_DC_loop_limiting_relay_flag			homol [72]
#define H_real_complex_impedance_setting		homol [73]
#define H_mercury_cioca_MSB_rx_gain			homol [74]
#define H_mercury_cioca_LSB_hybrid			homol [75]
#define H_mercury_ciocb_MSB_tx_gain			homol [76]
#define H_mercury_ciocb_LSB_BOM_control			homol [77]
#define H_mercury_ciocb_MSB_tx_gain_in_TAD_mode		homol [78]
#define H_mercury_ciocb_MSB_tx_gain_in_FDSP_mode	homol [79]
#define H_0xd6						homol [80]
#define H_0x7f						homol [0x7f - 0x86]

// Should really use the corresponding bytes in the array to
// hold the word values.
unsigned short S_0x4f, S_0x4b;
unsigned short S_0x5d, S_0x61, S_0x64;

#endif
