/*
 *	$Id: ltmodem.h,v 1.7 1999/12/01 04:11:13 root Exp $
 *
 *	Lucent PCI modem diagnostics tool.
 *
 *	Copyright (c) 1999 Richard J.M. Close
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 */

// Load configuration info.
#include "config.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <ctype.h>

#if TRY_INTERRUPTS
#include <signal.h>
#include <sys/wait.h>
#include "bb_threads.h"
#endif

#include "isa_utils.h"
#include "pci_utils.h"

#include "irq.h"
#include "control.h"
#include "voice.h"


/* Options */
static int verbose = 0;		        // Show detailed information.

#if TRY_INTERRUPTS
// Used for interrupt stuff.
static FILE* irq_dev;
static unsigned char interrupt_enabled;
static int irq_pid;
#endif

unsigned int portbase;
unsigned int modem_irq;

/* Modem monitoring functions. */
static void
monitor_modem(void);

static int
set_monitoring_interval(void);

/* Modem writing functions. */
static void
set_modem(void);

/* Main command menu. */
void main_menu(void);

void command_mode(void);

void setup_irq(void);

void show_modem(void);
 
void io_init(void);

// Default is tone dialling.
bool pulseDial = false;

// Dial the number held in the argument string.
void dial(char *s);

// Mess around with the speaker.
void setSpeaker (bool Enabled, unsigned char Volume);

bool waitForBusyTone (void);
bool waitForAnswerTone (void);
bool waitForDialTone (void);

void hangup (void);
void  waitForCall(void);

#if TRY_INTERRUPTS
// Spawned thread runs this interrupt servicing routine.
void catch_interrupts(void *data, size_t len);
#endif
