/*
 * "Voice" support for ltmodem
 *
 * Actually, as long as we don't want to use onboard DSP,
 * this is going to be used not only for voice but for
 * _everything_.
 *
 * Copyright 1999 Pavel Machek, distribute under GPL
 */
#ifndef LT_VOICE_H

#define LT_VOICE_H 1

#include <sys/time.h>
#include <sys/types.h>

#include "config.h"
#include "irq.h"
#include "portIO.h"
#include "control.h"

int dp_spk_volume;

void voice_init(void);

int voice_transmit(int fd_to_exit);

int dp_dualport_vc_Rc(void);
int dp_dualport_vc_Tx(void);

void dp_download_fdsp(void);

void dp_init_fdsp(void);

void dp_mute_fdsp(int arg);

void dp_stop_fdsp(void);

void dp_fdsp_record_start(void);
/* Strange, dp_start_spkphone is always called with 0 as argument ? */

void dp_start_spkphone(int arg);

void dp_init_hdsp(void);

void dp_start_hdsp(void);

void dp_switch_fdsp(void);
/*
 * Ouch, speakerphone is _not_ what is interesting for us.
 * TAD mode (telephone answering device) IS!
 */

void dp_download_tad(void);

void dp_detect_dtmf(void);

void dp_start_tad(int arg);

void dp_synth_ring_freq1(void);

void dp_synth_ring_freq2(void);

void dp_synth_ring_init(void);

void dp_synth_ring_on(void);

void dp_synth_ring_off(void);

// DSP code (defined in dsp.c).
extern unsigned char wDspFdsp[];
extern unsigned char wDspTad[];

// Stuff robbed from jamie.c
int io_voice_count, io_voice_count_rx;
int dp_vt_cntrl, dp_vsp, dp_monitor_hec, dp_dialtone_enable;

int dp_dualport_vc_Tx(void);
int dp_dualport_vc_Rc(void);
void dp_apollo_command(int a8, int aC, int a10, int a14, int a18, int a1c, int a20, int a24);

#endif
